//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3F6F202C00B3.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3F6F202C00B3.cm

//## begin module%3F6F202C00B3.cp preserve=no
//## end module%3F6F202C00B3.cp

//## Module: Cluster%3F6F202C00B3; Package specification
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/MixFunction/Cluster.h

#ifndef CLUSTER_H
#define CLUSTER_H 1

//## begin module%3F6F202C00B3.additionalIncludes preserve=no
//## end module%3F6F202C00B3.additionalIncludes

//## begin module%3F6F202C00B3.includes preserve=yes
//## end module%3F6F202C00B3.includes

// xsTypes
#include "xsTypes.h"
// utility
#include <utility>
// Error
#include <XSUtil/Error/Error.h>
// MixBase
#include <XSModel/Model/Component/MixBase.h>

//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    class DataContainer;
} // namespace XSContainer

class ClusterRegion;
class PsfImage;
class XRTResponse;

//## begin module%3F6F202C00B3.declarations preserve=no
//## end module%3F6F202C00B3.declarations

//## begin module%3F6F202C00B3.additionalDeclarations preserve=yes
//## end module%3F6F202C00B3.additionalDeclarations


//## begin Cluster%3F6F1DC503A1.preface preserve=yes
//## end Cluster%3F6F1DC503A1.preface

//## Class: Cluster%3F6F1DC503A1
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3F747F520083;XSContainer::DataContainer { -> F}
//## Uses: <unnamed>%3FBD0F6E02E2;ClusterRegion { -> F}
//## Uses: <unnamed>%40478BA801CB;PsfImage { -> F}
//## Uses: <unnamed>%405096AA03C0;XRTResponse { -> F}

class Cluster : public MixBase  //## Inherits: <unnamed>%3F6F1DD3004A
{
  //## begin Cluster%3F6F1DC503A1.initialDeclarations preserve=yes
  //## end Cluster%3F6F1DC503A1.initialDeclarations

  public:
    //## Class: ClusterError%3FCBC3B203E6
    //## Category: XSModel::Model::MixFunction%3F7461FF026E
    //## Subsystem: XSModel::Model::MixFunction%3F74624902C0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ClusterError : public YellowAlert  //## Inherits: <unnamed>%3FCBC3CB00C0
    {
      public:
        //## Constructors (specified)
          //## Operation: ClusterError%3FCBC4280045
          ClusterError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (specified)
      //## Operation: Cluster%405B1B3E0268
      Cluster (const string& name);

    //## Destructor (generated)
      virtual ~Cluster();


    //## Other Operations (specified)
      //## Operation: initialize%3F6F1DD80292
      virtual void initialize (const std::vector<Real>& params, const std::string& modelName = std::string(""));

      //## Operation: perform%3F7DE8A3018D
      virtual void perform (const EnergyPointer& energy, const std::vector<Real>& params, GroupFluxContainer& flux, GroupFluxContainer& fluxError);

      //## Operation: verifyData%3FBD058400CD
      virtual void verifyData () const;

      //## Operation: initializeForFit%3FBD05F503E4
      virtual void initializeForFit (const std::vector<Real>& params, bool paramsAreFixed);

      //## Operation: refreshTransform%405B56810188
      virtual void refreshTransform ();

  public:
    // Additional Public Declarations
      //## begin Cluster%3F6F1DC503A1.public preserve=yes
      //## end Cluster%3F6F1DC503A1.public

  protected:
    // Additional Protected Declarations
      //## begin Cluster%3F6F1DC503A1.protected preserve=yes
      //## end Cluster%3F6F1DC503A1.protected

  private:
    //## Constructors (generated)
      Cluster(const Cluster &right);

    //## Assignment Operation (generated)
      Cluster & operator=(const Cluster &right);


    //## Other Operations (specified)
      //## Operation: clearRegions%3FBD0DB8024C
      void clearRegions ();

      //## Operation: calcCentersOfEmission%40364377006E
      void calcCentersOfEmission ();

      //## Operation: clusterFact%403B72A5006A
      void clusterFact ();

      //## Operation: calcEngIndices%4044F64A02D6
      void calcEngIndices ();

      //## Operation: getOptic%4046339B00CB
      std::pair<Real,Real> getOptic (int instrument) const;

      //## Operation: isPixInRegions%40463DC1015D
      bool isPixInRegions (int instrument, int ix, int iy) const;

      //## Operation: calcCoordinates%40463E890094
      static void calcCoordinates (const Real xoff, const Real yoff, Real& theta, Real& phi);

      //## Operation: integrateSurfaceBrightness%4046400F01E1
      Real integrateSurfaceBrightness (const Real x, const Real y) const;

      //## Operation: findPsfEngBracket%404C960702C7
      int findPsfEngBracket (Real energy, int startFrom = 0) const;

      //## Operation: doPerform%40522DA20052
      void doPerform (GroupFluxContainer& fluxes, bool isError);

      //## Operation: calcGISEfficiency%4057123803C2
      void calcGISEfficiency (int inst);

      //## Operation: changedParameters%40575933004F
      bool changedParameters (const std::vector<Real>& params) const;

    // Additional Private Declarations
      //## begin Cluster%3F6F1DC503A1.private preserve=yes
      //## end Cluster%3F6F1DC503A1.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: alpha%3FBD088203A8
      //## begin Cluster::alpha%3FBD088203A8.attr preserve=no  private: Real {U} 
      Real m_alpha;
      //## end Cluster::alpha%3FBD088203A8.attr

      //## Attribute: beta%3FBD088A0356
      //## begin Cluster::beta%3FBD088A0356.attr preserve=no  private: Real {U} 
      Real m_beta;
      //## end Cluster::beta%3FBD088A0356.attr

      //## Attribute: core%3FBD089000E6
      //## begin Cluster::core%3FBD089000E6.attr preserve=no  private: Real {U} 
      Real m_core;
      //## end Cluster::core%3FBD089000E6.attr

      //## Attribute: sbModelType%3FBD0918004A
      //## begin Cluster::sbModelType%3FBD0918004A.attr preserve=no  private: int {U} 
      int m_sbModelType;
      //## end Cluster::sbModelType%3FBD0918004A.attr

      //## Attribute: factArray%3FBD09D7010D
      //## begin Cluster::factArray%3FBD09D7010D.attr preserve=no  private: RealArray {U} 
      RealArray m_factArray;
      //## end Cluster::factArray%3FBD09D7010D.attr

      //## Attribute: parametersAreFrozen%3FBD09ED015A
      //## begin Cluster::parametersAreFrozen%3FBD09ED015A.attr preserve=no  private: bool {U} 
      bool m_parametersAreFrozen;
      //## end Cluster::parametersAreFrozen%3FBD09ED015A.attr

      //## Attribute: regions%3FBD0D510100
      //## begin Cluster::regions%3FBD0D510100.attr preserve=no  private: std::vector<std::vector<ClusterRegion*> > {U} 
      std::vector<std::vector<ClusterRegion*> > m_regions;
      //## end Cluster::regions%3FBD0D510100.attr

      //## Attribute: instInUse%403B9705038B
      //## begin Cluster::instInUse%403B9705038B.attr preserve=no  private: BoolArray {U} 
      BoolArray m_instInUse;
      //## end Cluster::instInUse%403B9705038B.attr

      //## Attribute: psfEnergy%403BBD370189
      //## begin Cluster::psfEnergy%403BBD370189.attr preserve=no  private: RealArray {U} 
      RealArray m_psfEnergy;
      //## end Cluster::psfEnergy%403BBD370189.attr

      //## Attribute: modelName%403FC24F01B1
      //## begin Cluster::modelName%403FC24F01B1.attr preserve=no  private: std::string {U} 
      std::string m_modelName;
      //## end Cluster::modelName%403FC24F01B1.attr

      //## Attribute: engIndices%4044F5DC0380
      //## begin Cluster::engIndices%4044F5DC0380.attr preserve=no  private: std::vector<std::vector<int> > {U} 
      std::vector<std::vector<int> > m_engIndices;
      //## end Cluster::engIndices%4044F5DC0380.attr

      //## Attribute: PI%404748F2038C
      //## begin Cluster::PI%404748F2038C.attr preserve=no  private: static Real {U} 4.*atan(1.)
      static Real s_PI;
      //## end Cluster::PI%404748F2038C.attr

      //## Attribute: psfImage%40478BD203CD
      //## begin Cluster::psfImage%40478BD203CD.attr preserve=no  private: PsfImage* {U} 
      PsfImage* m_psfImage;
      //## end Cluster::psfImage%40478BD203CD.attr

      //## Attribute: psfFileName%404797790080
      //## begin Cluster::psfFileName%404797790080.attr preserve=no  private: static const string {U} string("allpsf.nosm.fits")
      static const string s_psfFileName;
      //## end Cluster::psfFileName%404797790080.attr

      //## Attribute: weight%4048EFF500A1
      //## begin Cluster::weight%4048EFF500A1.attr preserve=no  private: RealArray {U} 
      RealArray m_weight;
      //## end Cluster::weight%4048EFF500A1.attr

      //## Attribute: xrtFileName%4052160E033D
      //## begin Cluster::xrtFileName%4052160E033D.attr preserve=no  private: static const string {U} string("xrt_ea.fits")
      static const string s_xrtFileName;
      //## end Cluster::xrtFileName%4052160E033D.attr

      //## Attribute: xrtResponse%40521677018E
      //## begin Cluster::xrtResponse%40521677018E.attr preserve=no  private: XRTResponse* {U} 
      XRTResponse* m_xrtResponse;
      //## end Cluster::xrtResponse%40521677018E.attr

      //## Attribute: dataChanged%405B565203CD
      //## begin Cluster::dataChanged%405B565203CD.attr preserve=no  private: bool {U} 
      bool m_dataChanged;
      //## end Cluster::dataChanged%405B565203CD.attr

      //## Attribute: allEnergies%405B7ADD020C
      //## begin Cluster::allEnergies%405B7ADD020C.attr preserve=no  private: EnergyPointer {U} 
      EnergyPointer m_allEnergies;
      //## end Cluster::allEnergies%405B7ADD020C.attr

    // Data Members for Associations

      //## Association: XSModel::Model::MixFunction::<unnamed>%403641B600AB
      //## Role: Cluster::centers%403641BA019C
      //## begin Cluster::centers%403641BA019C.role preserve=no  private: std::pair< Real,Real > { -> 1..nVHgN}
      std::vector<std::pair< Real,Real > > m_centers;
      //## end Cluster::centers%403641BA019C.role

      //## Association: XSModel::Model::MixFunction::<unnamed>%40479CD6001F
      //## Role: Cluster::psfArray%40479CD80291
      //## begin Cluster::psfArray%40479CD80291.role preserve=no  private: RealArray { -> 1..nVHgN}
      std::vector<RealArray> m_psfArray;
      //## end Cluster::psfArray%40479CD80291.role

    // Additional Implementation Declarations
      //## begin Cluster%3F6F1DC503A1.implementation preserve=yes
      //## end Cluster%3F6F1DC503A1.implementation

};

//## begin Cluster%3F6F1DC503A1.postscript preserve=yes
//## end Cluster%3F6F1DC503A1.postscript

// Class Cluster::ClusterError 

// Class Cluster 

//## begin module%3F6F202C00B3.epilog preserve=yes
//## end module%3F6F202C00B3.epilog


#endif
